﻿Type=Class
Version=2.00
@EndOfDesignText@
'Class module
Private Sub Class_Globals
Dim dr3 As BitmapDrawable	
End Sub

'Initializes the object, returns a BitmapDrawable. 
'platesize is between 0 to 1
Public Sub Initialize(InColor As Int, OutColor As Int, platesize As Float) As BitmapDrawable

Dim r As Rect
Dim bmp As Bitmap
Dim cnvs As Canvas
Dim argb1(),argb2(), tcolor, S As Int

bmp.InitializeMutable(100,100)
cnvs.Initialize2(bmp)

argb1 = GetARGB(InColor)
argb2 = GetARGB(OutColor)

r.Initialize(0,0,100,100)
cnvs.DrawRect(r, Colors.Transparent,True,2)
S = 50*(1-platesize)
For i =  S To 1 Step -1
	tcolor = Colors.argb(argb1(0) + i* (argb2(0) - argb1(0))/S, _
						 argb1(1) + i* (argb2(1) - argb1(1))/S, _
						 argb1(2) + i* (argb2(2) - argb1(2))/S, _
						 argb1(3) + i* (argb2(3) - argb1(3))/S)
	cnvs.DrawCircle(50,50, i + 50*platesize ,tcolor,True,2)
Next
dr3.Initialize( bmp)
Return dr3
End Sub

Sub AsObject As BitmapDrawable
Return dr3
End Sub

Private Sub GetARGB(Color As Int) As Int()
    Dim res(4) As Int
    res(0) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff000000), 24)
    res(1) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff0000), 16)
    res(2) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff00), 8)
    res(3) = Bit.And(Color, 0xff)
    Return res
End Sub